Bug 9443 - mcs failed to compile explicit interface implementation if the method has parameter that is generic type with constraint type parameter
Summary: mcs failed to compile explicit interface implementation if the method has par...
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: unspecified
Hardware: PC Linux
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2013-01-10 02:47 UTC by wanghengwei
Modified: 2013-01-14 11:00 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description wanghengwei 2013-01-10 02:47:33 UTC
debian testing
mcs 2.10.8.1

Consider the following code:

//file bug.cs
using System;

interface IParam<T>
  where T : IParam<T>
{}

interface IA
{
  void f<T>(IParam<T> p)
    where T : IParam<T>;
}

class A : IA
{
  void IA.f<T>(IParam<T> p)
  {
  }
}

//end

there's an error while compiling with mcs -t:library:

bug.cs(17,30): error CS0314: The type `T' cannot be used as type parameter `T' in the generic type or method `a.IParam<T>'. There is no boxing or type parameter conversion from `T' to `a.IParam<T>'

ms csc is ok.

if changing the explicit implementation to implicit, there's no error:
//this is ok
class A : IA
{
  public void f<T>(IParam<T> p)
    where T : IParam<T>
  {
  }
}
Comment 1 Marek Safar 2013-01-14 11:00:55 UTC
Fixed in master